---
product: "AG Grid"
title: "Quick Access Toolbar"
description: "The Toolbar appears above the grid and provides quick access to common grid actions. It supports built-in items such as quick filter and find, dropdown menus, and can be extended with or ."
enterprise: true
framework: javascript
version: "36.2.0"
related:
    - title: "Tool Panels"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tool-panel/"
    - title: "Column Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-menu/"
    - title: "Column Chooser"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-chooser/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/context-menu/"
    - title: "Menu Item Component"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/component-menu-item/"
    - title: "Status Bar"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/status-bar/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Quick Access Toolbar

The Toolbar appears above the grid and provides quick access to common grid actions. It supports built-in items such as quick filter and find, dropdown menus, and can be extended with [Action Buttons](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/toolbar/#action-buttons) or [Custom Components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/toolbar/#custom-components).

#### Built-in Items

```ts
import {
  ClientSideRowModelModule,
  ColumnAutoSizeModule,
  CsvExportModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  QuickFilterModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  FindModule,
  PdfExportModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnAutoSizeModule,
  ContextMenuModule,
  CsvExportModule,
  ExcelExportModule,
  PdfExportModule,
  FindModule,
  QuickFilterModule,
  ToolbarModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete" },
    { field: "country" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ],
  defaultColDef: {
    minWidth: 100,
    filter: true,
  },
  toolbar: {
    items: [
      "agQuickFilterToolbarItem",
      "separator",
      "agFindToolbarItem",
      "separator",
      {
        label: "Fit Columns To Grid",
        icon: "maximize",
        alignment: "right",
        action: (params) => params.api.sizeColumnsToFit(),
      },
      {
        toolbarItem: "agMenuToolbarItem",
        icon: "save",
        alignment: "right",
        label: "Export",
        tooltip: "Export as CSV, Excel or PDF",
        toolbarItemParams: {
          menuItems: ["csvExport", "excelExport", "pdfExport"],
        },
      },
    ],
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Built-in Items](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/built-in-items/typescript/)

## Configuring the Toolbar

Set the `toolbar` grid option to a [Toolbar](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grid-options/#reference-accessories-toolbar) object. The `items` array accepts built-in item names, [Action Buttons](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/toolbar/#action-buttons), and [Custom Components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/toolbar/#custom-components).

```js
const gridOptions = {
    toolbar: {
        items: [
            'agQuickFilterToolbarItem',
            'separator',
            'agFindToolbarItem',
            'separator',
            {
                label: 'Fit Columns To Grid',
                icon: 'maximize',
                alignment: 'right',
                action: (params) => params.api.sizeColumnsToFit(),
            },
            {
                toolbarItem: 'agMenuToolbarItem',
                icon: 'save',
                alignment: 'right',
                label: 'Download',
                tooltip: 'Download as CSV, Excel or PDF',
                toolbarItemParams: {
                    menuItems: ['csvExport', 'excelExport', 'pdfExport'],
                },
            },
        ],
    },

    // other grid options ...
}
```

### Alignment

Toolbar items are aligned to the left by default. Set the `alignment` property on the toolbar to change the default alignment for all items, or set it individually per item.

```js
const gridOptions = {
    toolbar: {
        alignment: 'right',
        items: [
            'agFindToolbarItem',
            { toolbarItem: 'agQuickFilterToolbarItem', alignment: 'left' },
        ]
    },

    // other grid options ...
}
```

## Built-in Items

A number of built-in toolbar items are provided for common use cases that integrate with existing grid features. Be sure to include the required feature module, otherwise the toolbar item will be excluded.

| Item | Description | Required Modules |
| --- | --- | --- |
| `agQuickFilterToolbarItem` | Text input that filters grid rows using the [Quick Filter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-quick/). | `QuickFilterModule` |
| `agFindToolbarItem` | Text input that searches within grid cells using [Find](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/find/). | `FindModule` |
| `agRowGroupPanelToolbarItem` | Embeds the [Row Group Panel](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-group-panel/). | `RowGroupingPanelModule` |
| `agPivotPanelToolbarItem` | Embeds the [Pivot Panel](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/pivoting/#enabling-the-pivot-panel). | `RowGroupingPanelModule` |
| [`agMenuToolbarItem`](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/toolbar/#dropdown-menus) | Button that opens a [dropdown menu](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/toolbar/#dropdown-menus). | `ContextMenuModule` or `ColumnMenuModule` |
| `separator` | Vertical divider used to group items visually. Has no behaviour of its own. | None |

The Find and Quick Filter items' inputs share the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/input-fields/).

### Row Group and Pivot Panels

The Row Group Panel and Pivot Panel can both be embedded in the Quick Access Toolbar using `agRowGroupPanelToolbarItem` and `agPivotPanelToolbarItem`. Both panels are configured independently of the [Row Group Panel](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-group-panel/) and the [Pivot Panel](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/pivoting/#enabling-the-pivot-panel), so you can display each panel in the Toolbar, above the grid, or both at the same time.

The example below shows both panels in the toolbar along with a reset action button. Use the panels to rearrange columns, then click Reset to restore the initial layout.

#### Row Group and Pivot Panels

```ts
import {
  ClientSideRowModelModule,
  ColumnApiModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  PivotModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnApiModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  PivotModule,
  ToolbarModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "country", enableRowGroup: true, rowGroup: true },
    { field: "year", enableRowGroup: true, enablePivot: true, pivot: true },
    { field: "sport", enableRowGroup: true, enablePivot: true },
    { field: "gold", enableValue: true, aggFunc: "sum" },
    { field: "silver", enableValue: true, aggFunc: "sum" },
    { field: "total", enableValue: true, aggFunc: "sum" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 120,
  },
  autoGroupColumnDef: {
    minWidth: 200,
  },
  pivotMode: true,
  toolbar: {
    items: [
      "agRowGroupPanelToolbarItem",
      "separator",
      "agPivotPanelToolbarItem",
      "separator",
      {
        icon: "columns",
        label: "Reset",
        alignment: "right",
        action: (params) => {
          params.api.setGridOption("pivotMode", true);
          params.api.resetColumnState();
        },
      },
    ],
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Row Group and Pivot Panels](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/row-group-pivot-panels/typescript/)

### Dropdown Menus

Use the `agMenuToolbarItem` to render a dropdown of [Menu Items](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/component-menu-item/). Configure the button and menu contents using the following properties:

- `label`: Visible text rendered next to the icon. Omit to render an icon-only button.
- `icon`: Icon displayed on the button. Accepts any [provided icon](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/custom-icons/#provided-icons).
- `tooltip`: Hover tooltip and `aria-label`. Falls back to `label` when omitted.
- `toolbarItemParams.menuItems`: Items to include in the dropdown. Each entry is either a `MenuItemDef` or one of the [built-in](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/context-menu/#built-in-menu-items) menu item names as used by the Context Menu.

```js
const gridOptions = {
    toolbar: {
        items: [
            {
                toolbarItem: 'agMenuToolbarItem',
                icon: 'save',
                toolbarItemParams: {
                    menuItems: ['csvExport', 'excelExport', 'pdfExport'],
                },
            },
        ],
    },

    // other grid options ...
}
```

## Action Buttons

Action buttons provide a convenient way to trigger custom behaviour on click of a toolbar item. Configure an action button using the following properties:

- `label`: Visible text rendered next to the icon. Omit to render an icon-only button.
- `icon`: Icon displayed on the button. Accepts any [provided icon](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/custom-icons/#provided-icons).
- `tooltip`: Hover tooltip and `aria-label`. Falls back to `label` when omitted.
- `action`: Callback fired on click. Receives the grid `api`, `context`, and the item `key`.

```js
const gridOptions = {
    toolbar: {
        items: [
            {
                key: 'autoSizeAll',
                label: 'Auto Size All',
                icon: 'maximize',
                action: (params) => params.api.autoSizeAllColumns(),
            },
        ],
    },

    // other grid options ...
}
```

The example below shows icon-only buttons with tooltips for sizing columns, sorting, and resetting filters and column state, divided by separators.

#### Action Buttons

```ts
import {
  ClientSideRowModelModule,
  ColumnApiModule,
  ColumnAutoSizeModule,
  CsvExportModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  TextFilterModule,
  NumberFilterModule,
  ColumnMenuModule,
  CsvExportModule,
  ColumnAutoSizeModule,
  ColumnApiModule,
  ContextMenuModule,
  ToolbarModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete" },
    { field: "country", filter: "agTextColumnFilter" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ],
  defaultColDef: {
    minWidth: 100,
    filter: true,
  },
  toolbar: {
    items: [
      {
        key: "sizeColumnsToFit",
        icon: "maximize",
        tooltip: "Size Columns to Fit",
        action: (params) => params.api.sizeColumnsToFit(),
      },
      {
        key: "autoSizeAll",
        icon: "minimize",
        tooltip: "Auto-size All Columns",
        action: (params) => params.api.autoSizeAllColumns(),
      },
      "separator",
      {
        key: "sortFirstColumnAsc",
        icon: "sortAscending",
        tooltip: "Sort First Column Ascending",
        action: (params) =>
          params.api.applyColumnState({
            state: [{ colId: "athlete", sort: "asc" }],
            defaultState: { sort: null },
          }),
      },
      {
        key: "sortFirstColumnDesc",
        icon: "sortDescending",
        tooltip: "Sort First Column Descending",
        action: (params) =>
          params.api.applyColumnState({
            state: [{ colId: "athlete", sort: "desc" }],
            defaultState: { sort: null },
          }),
      },
      "separator",
      {
        key: "addFilter",
        icon: "filter-add",
        tooltip: "Add Filter",
        action: (params) =>
          params.api.setFilterModel({
            country: { filterType: "text", type: "contains", filter: "Canada" },
          }),
      },
      {
        key: "clearFilters",
        icon: "filterActive",
        tooltip: "Clear All Filters",
        action: (params) => params.api.setFilterModel(null),
      },
      "separator",
      {
        key: "showColumnChooser",
        icon: "columns",
        tooltip: "Open Column Chooser",
        action: (params) => params.api.showColumnChooser(),
      },
    ],
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Action Buttons](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/action-buttons/typescript/)

## Custom Components

For controls beyond a button, such as toggles, inputs, or any stateful UI, set `toolbarItem` to a custom component. Custom components can render arbitrary HTML and call any grid API, so they suit cases that the [Action Button](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/toolbar/#action-buttons) shorthand cannot express.

The example below defines two custom items: checkbox toggles that apply column filters on the left, and a radio group that opens [Side Bar](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tool-panel/) tool panels on the right. The radio group's `setSelected` method is called via [`getToolbarItemInstance`](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/toolbar/#reference-accessories-getToolbarItemInstance) in `onToolPanelVisibleChanged` to stay in sync when a panel is opened or closed elsewhere, such as via a sidebar tab.

#### Custom Toolbar Item

```ts
import {
  AllCommunityModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  ToolPanelVisibleChangedEvent,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  SideBarModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { ToolPanelRadio, WinnersToggle } from "./customToolbarItem";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  AllCommunityModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  SideBarModule,
  ToolbarModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete" },
    { field: "country" },
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze" },
  ],
  defaultColDef: {
    minWidth: 100,
    filter: true,
  },
  sideBar: { toolPanels: ["columns", "filters"] },
  toolbar: {
    items: [
      { toolbarItem: WinnersToggle, key: "winners" },
      { toolbarItem: ToolPanelRadio, key: "toolPanel", alignment: "right" },
    ],
  },
  onToolPanelVisibleChanged: (event: ToolPanelVisibleChangedEvent) => {
    const radio = event.api.getToolbarItemInstance<ToolPanelRadio>("toolPanel");
    radio?.setSelected(event.visible ? event.key : "none");
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Custom Toolbar Item](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/toolbar-custom/typescript/)

When defining a custom component, provide the `toolbarItem` with:

1. `String`: the name of a registered Toolbar Item Component. See [Registering Custom Components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/components/#registering-custom-components).
2. `Class`: a direct reference to a Toolbar Item Component.

```js
// WinnersToggle and ToolPanelRadio are the custom components defined above.
// Any toolbarItemParams set on the item are accessible via params.toolbarItemParams inside the component.
const gridOptions = {
    toolbar: {
        items: [
            { toolbarItem: WinnersToggle, key: 'winners' },
            { toolbarItem: ToolPanelRadio, key: 'toolPanel', alignment: 'right' },
        ],
    },
    // ...other properties
}
```

Implement this interface to create a toolbar item component.

```ts
interface IToolbarItemComp {
    // mandatory methods

    // Return the DOM element of your component, this is what the grid puts into the DOM.
    getGui(): HTMLElement;

    // optional methods

    // The init(params) method is called on the toolbar item component once.
    // See below for details on the parameters.
    init(params: IToolbarItemParams): void;

    // Called when the `toolbar` grid option updates.
    // Return `true` if the component updates itself with the new params.
    // Return `false` (or omit) to have the grid destroy and recreate the component.
    refresh(params: IToolbarItemParams): boolean;

    // Gets called when the grid is destroyed.
    // If your toolbar item needs to do any cleanup, do it here.
    destroy(): void;
}
```

The `init(params)` method receives a params object that implements `IToolbarItemParams`:

## Theme Parameters

The toolbar exposes the following [Theme Parameters](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-parameters/):

| Parameter | Description |
| --- | --- |
| `toolbarBackgroundColor` | Background colour of the toolbar. Defaults to the header background colour. |
| `toolbarTextColor` | Text colour in the toolbar. Defaults to the header text colour. |
| `toolbarSeparatorBorder` | Border style for the vertical separator between toolbar items. |

## Accessing Toolbar Items

To access a toolbar item instance use the grid api method `getToolbarItemInstance(key)`. The `key` must match a `key` set on the item definition; items without an explicit key are not reachable via the API. This is demonstrated in the [Custom Components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/toolbar/#custom-components) example above, where it's used to keep a toolbar radio in sync with side bar tool panel changes.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getToolbarItemInstance` | `Function` |  |  |  |

## API Reference

### Toolbar

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `toolbar` | `Toolbar` |  |  |  |

### IToolbarItemParams

Properties available on the `IToolbarItemParams&lt;TData = any, TContext = any, TParams = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `key` | `string` |  |  |  |
| `alignment` | `'left' \| 'right'` |  |  |  |
| `toolbarItemParams` | `TParams` |  |  |  |
| `label` | `string` |  |  |  |
| `tooltip` | `string` |  |  |  |
| `icon` | `IconName` |  |  |  |
| `action` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |


---
product: "AG Grid"
title: "Quick Access Toolbar"
description: "The Toolbar appears above the grid and provides quick access to common grid actions. It supports built-in items such as quick filter and find, dropdown menus, and can be extended with or ."
enterprise: true
framework: vue
version: "36.2.0"
related:
    - title: "Tool Panels"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tool-panel/"
    - title: "Column Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-menu/"
    - title: "Column Chooser"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-chooser/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/context-menu/"
    - title: "Menu Item Component"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/component-menu-item/"
    - title: "Status Bar"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/status-bar/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Quick Access Toolbar

The Toolbar appears above the grid and provides quick access to common grid actions. It supports built-in items such as quick filter and find, dropdown menus, and can be extended with [Action Buttons](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/toolbar/#action-buttons) or [Custom Components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/toolbar/#custom-components).

#### Built-in Items

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnAutoSizeModule,
  CsvExportModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  QuickFilterModule,
  TextFilterModule,
  Toolbar,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  FindModule,
  PdfExportModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnAutoSizeModule,
  ContextMenuModule,
  CsvExportModule,
  ExcelExportModule,
  PdfExportModule,
  FindModule,
  QuickFilterModule,
  ToolbarModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :toolbar="toolbar"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "country" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
    ]);
    const defaultColDef = ref<ColDef>({
      minWidth: 100,
      filter: true,
    });
    const toolbar = ref<Toolbar>({
      items: [
        "agQuickFilterToolbarItem",
        "separator",
        "agFindToolbarItem",
        "separator",
        {
          label: "Fit Columns To Grid",
          icon: "maximize",
          alignment: "right",
          action: (params) => params.api.sizeColumnsToFit(),
        },
        {
          toolbarItem: "agMenuToolbarItem",
          icon: "save",
          alignment: "right",
          label: "Export",
          tooltip: "Export as CSV, Excel or PDF",
          toolbarItemParams: {
            menuItems: ["csvExport", "excelExport", "pdfExport"],
          },
        },
      ],
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      toolbar,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Built-in Items](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/built-in-items/vue3/)

## Configuring the Toolbar

Set the `toolbar` grid option to a [Toolbar](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grid-options/#reference-accessories-toolbar) object. The `items` array accepts built-in item names, [Action Buttons](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/toolbar/#action-buttons), and [Custom Components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/toolbar/#custom-components).

```ts
<ag-grid-vue
    :toolbar="toolbar"
    /* other grid options ... */>
</ag-grid-vue>

this.toolbar = {
    items: [
        'agQuickFilterToolbarItem',
        'separator',
        'agFindToolbarItem',
        'separator',
        {
            label: 'Fit Columns To Grid',
            icon: 'maximize',
            alignment: 'right',
            action: (params) => params.api.sizeColumnsToFit(),
        },
        {
            toolbarItem: 'agMenuToolbarItem',
            icon: 'save',
            alignment: 'right',
            label: 'Download',
            tooltip: 'Download as CSV, Excel or PDF',
            toolbarItemParams: {
                menuItems: ['csvExport', 'excelExport', 'pdfExport'],
            },
        },
    ],
};
```

### Alignment

Toolbar items are aligned to the left by default. Set the `alignment` property on the toolbar to change the default alignment for all items, or set it individually per item.

```ts
<ag-grid-vue
    :toolbar="toolbar"
    /* other grid options ... */>
</ag-grid-vue>

this.toolbar = {
    alignment: 'right',
    items: [
        'agFindToolbarItem',
        { toolbarItem: 'agQuickFilterToolbarItem', alignment: 'left' },
    ]
};
```

## Built-in Items

A number of built-in toolbar items are provided for common use cases that integrate with existing grid features. Be sure to include the required feature module, otherwise the toolbar item will be excluded.

| Item | Description | Required Modules |
| --- | --- | --- |
| `agQuickFilterToolbarItem` | Text input that filters grid rows using the [Quick Filter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-quick/). | `QuickFilterModule` |
| `agFindToolbarItem` | Text input that searches within grid cells using [Find](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/find/). | `FindModule` |
| `agRowGroupPanelToolbarItem` | Embeds the [Row Group Panel](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-group-panel/). | `RowGroupingPanelModule` |
| `agPivotPanelToolbarItem` | Embeds the [Pivot Panel](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/pivoting/#enabling-the-pivot-panel). | `RowGroupingPanelModule` |
| [`agMenuToolbarItem`](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/toolbar/#dropdown-menus) | Button that opens a [dropdown menu](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/toolbar/#dropdown-menus). | `ContextMenuModule` or `ColumnMenuModule` |
| `separator` | Vertical divider used to group items visually. Has no behaviour of its own. | None |

The Find and Quick Filter items' inputs share the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/input-fields/).

### Row Group and Pivot Panels

The Row Group Panel and Pivot Panel can both be embedded in the Quick Access Toolbar using `agRowGroupPanelToolbarItem` and `agPivotPanelToolbarItem`. Both panels are configured independently of the [Row Group Panel](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-group-panel/) and the [Pivot Panel](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/pivoting/#enabling-the-pivot-panel), so you can display each panel in the Toolbar, above the grid, or both at the same time.

The example below shows both panels in the toolbar along with a reset action button. Use the panels to rearrange columns, then click Reset to restore the initial layout.

#### Row Group and Pivot Panels

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Toolbar,
  enableDevValidations,
} from "ag-grid-community";
import {
  PivotModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnApiModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  PivotModule,
  ToolbarModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :autoGroupColumnDef="autoGroupColumnDef"
      :pivotMode="true"
      :toolbar="toolbar"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "country", enableRowGroup: true, rowGroup: true },
      { field: "year", enableRowGroup: true, enablePivot: true, pivot: true },
      { field: "sport", enableRowGroup: true, enablePivot: true },
      { field: "gold", enableValue: true, aggFunc: "sum" },
      { field: "silver", enableValue: true, aggFunc: "sum" },
      { field: "total", enableValue: true, aggFunc: "sum" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 120,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
    });
    const toolbar = ref<Toolbar>({
      items: [
        "agRowGroupPanelToolbarItem",
        "separator",
        "agPivotPanelToolbarItem",
        "separator",
        {
          icon: "columns",
          label: "Reset",
          alignment: "right",
          action: (params) => {
            params.api.setGridOption("pivotMode", true);
            params.api.resetColumnState();
          },
        },
      ],
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      toolbar,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Row Group and Pivot Panels](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/row-group-pivot-panels/vue3/)

### Dropdown Menus

Use the `agMenuToolbarItem` to render a dropdown of [Menu Items](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/component-menu-item/). Configure the button and menu contents using the following properties:

- `label`: Visible text rendered next to the icon. Omit to render an icon-only button.
- `icon`: Icon displayed on the button. Accepts any [provided icon](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/custom-icons/#provided-icons).
- `tooltip`: Hover tooltip and `aria-label`. Falls back to `label` when omitted.
- `toolbarItemParams.menuItems`: Items to include in the dropdown. Each entry is either a `MenuItemDef` or one of the [built-in](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/context-menu/#built-in-menu-items) menu item names as used by the Context Menu.

```ts
<ag-grid-vue
    :toolbar="toolbar"
    /* other grid options ... */>
</ag-grid-vue>

this.toolbar = {
    items: [
        {
            toolbarItem: 'agMenuToolbarItem',
            icon: 'save',
            toolbarItemParams: {
                menuItems: ['csvExport', 'excelExport', 'pdfExport'],
            },
        },
    ],
};
```

## Action Buttons

Action buttons provide a convenient way to trigger custom behaviour on click of a toolbar item. Configure an action button using the following properties:

- `label`: Visible text rendered next to the icon. Omit to render an icon-only button.
- `icon`: Icon displayed on the button. Accepts any [provided icon](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/custom-icons/#provided-icons).
- `tooltip`: Hover tooltip and `aria-label`. Falls back to `label` when omitted.
- `action`: Callback fired on click. Receives the grid `api`, `context`, and the item `key`.

```ts
<ag-grid-vue
    :toolbar="toolbar"
    /* other grid options ... */>
</ag-grid-vue>

this.toolbar = {
    items: [
        {
            key: 'autoSizeAll',
            label: 'Auto Size All',
            icon: 'maximize',
            action: (params) => params.api.autoSizeAllColumns(),
        },
    ],
};
```

The example below shows icon-only buttons with tooltips for sizing columns, sorting, and resetting filters and column state, divided by separators.

#### Action Buttons

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  ColumnAutoSizeModule,
  CsvExportModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  Toolbar,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  TextFilterModule,
  NumberFilterModule,
  ColumnMenuModule,
  CsvExportModule,
  ColumnAutoSizeModule,
  ColumnApiModule,
  ContextMenuModule,
  ToolbarModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :toolbar="toolbar"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "country", filter: "agTextColumnFilter" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
    ]);
    const defaultColDef = ref<ColDef>({
      minWidth: 100,
      filter: true,
    });
    const toolbar = ref<Toolbar>({
      items: [
        {
          key: "sizeColumnsToFit",
          icon: "maximize",
          tooltip: "Size Columns to Fit",
          action: (params) => params.api.sizeColumnsToFit(),
        },
        {
          key: "autoSizeAll",
          icon: "minimize",
          tooltip: "Auto-size All Columns",
          action: (params) => params.api.autoSizeAllColumns(),
        },
        "separator",
        {
          key: "sortFirstColumnAsc",
          icon: "sortAscending",
          tooltip: "Sort First Column Ascending",
          action: (params) =>
            params.api.applyColumnState({
              state: [{ colId: "athlete", sort: "asc" }],
              defaultState: { sort: null },
            }),
        },
        {
          key: "sortFirstColumnDesc",
          icon: "sortDescending",
          tooltip: "Sort First Column Descending",
          action: (params) =>
            params.api.applyColumnState({
              state: [{ colId: "athlete", sort: "desc" }],
              defaultState: { sort: null },
            }),
        },
        "separator",
        {
          key: "addFilter",
          icon: "filter-add",
          tooltip: "Add Filter",
          action: (params) =>
            params.api.setFilterModel({
              country: {
                filterType: "text",
                type: "contains",
                filter: "Canada",
              },
            }),
        },
        {
          key: "clearFilters",
          icon: "filterActive",
          tooltip: "Clear All Filters",
          action: (params) => params.api.setFilterModel(null),
        },
        "separator",
        {
          key: "showColumnChooser",
          icon: "columns",
          tooltip: "Open Column Chooser",
          action: (params) => params.api.showColumnChooser(),
        },
      ],
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      toolbar,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Action Buttons](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/action-buttons/vue3/)

## Custom Components

For controls beyond a button, such as toggles, inputs, or any stateful UI, set `toolbarItem` to a custom component. Custom components can render arbitrary HTML and call any grid API, so they suit cases that the [Action Button](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/toolbar/#action-buttons) shorthand cannot express.

The example below defines two custom items: checkbox toggles that apply column filters on the left, and a radio group that opens [Side Bar](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tool-panel/) tool panels on the right. The radio group's `setSelected` method is called via [`getToolbarItemInstance`](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/toolbar/#reference-accessories-getToolbarItemInstance) in `onToolPanelVisibleChanged` to stay in sync when a panel is opened or closed elsewhere, such as via a sidebar tab.

#### Custom Toolbar Item

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  AllCommunityModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  ToolPanelVisibleChangedEvent,
  Toolbar,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  SideBarModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import ToolPanelRadio from "./toolPanelRadioVue";
import WinnersToggle from "./winnersToggleVue";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  AllCommunityModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  SideBarModule,
  ToolbarModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :sideBar="sideBar"
      :toolbar="toolbar"
      :rowData="rowData"
      @tool-panel-visible-changed="onToolPanelVisibleChanged"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    ToolPanelRadio,
    WinnersToggle,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "country" },
      { field: "gold", filter: "agNumberColumnFilter" },
      { field: "silver", filter: "agNumberColumnFilter" },
      { field: "bronze" },
    ]);
    const defaultColDef = ref<ColDef>({
      minWidth: 100,
      filter: true,
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>({
      toolPanels: ["columns", "filters"],
    });
    const toolbar = ref<Toolbar>({
      items: [
        { toolbarItem: "WinnersToggle", key: "winners" },
        { toolbarItem: "ToolPanelRadio", key: "toolPanel", alignment: "right" },
      ],
    });
    const rowData = ref<IOlympicData[]>(null);

    function onToolPanelVisibleChanged(event: ToolPanelVisibleChangedEvent) {
      const radio =
        event.api.getToolbarItemInstance<ToolPanelRadio>("toolPanel");
      radio?.setSelected(event.visible ? event.key : "none");
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      sideBar,
      toolbar,
      rowData,
      onGridReady,
      onToolPanelVisibleChanged,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Custom Toolbar Item](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/toolbar-custom/vue3/)

When defining a custom component, provide the `toolbarItem` with:

1. `String`: the name of a registered Toolbar Item Component. See [Registering Custom Components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/components/#registering-custom-components).

```js
// winnersToggle and toolPanelRadio are the custom components defined above.
// Any toolbarItemParams set on the item are accessible via this.params.toolbarItemParams inside the component.
this.gridOptions = {
    toolbar: {
        items: [
            { toolbarItem: 'winnersToggle', key: 'winners' },
            { toolbarItem: 'toolPanelRadio', key: 'toolPanel', alignment: 'right' },
        ],
    },
    // ...other properties
}
```

Any valid Vue component can be a toolbar item component, however it is also possible to implement the following optional methods:

```ts
interface IToolbarItem {
    // Called when the `toolbar` grid option updates.
    // Return `true` if the component updates itself with the new params.
    // Return `false` (or omit) to have the grid destroy and recreate the component.
    refresh(params: IToolbarItemParams): boolean;
}
```

When a custom toolbar item component is instantiated then the following will be made available on `this.params`:

## Theme Parameters

The toolbar exposes the following [Theme Parameters](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-parameters/):

| Parameter | Description |
| --- | --- |
| `toolbarBackgroundColor` | Background colour of the toolbar. Defaults to the header background colour. |
| `toolbarTextColor` | Text colour in the toolbar. Defaults to the header text colour. |
| `toolbarSeparatorBorder` | Border style for the vertical separator between toolbar items. |

## Accessing Toolbar Items

To access a toolbar item instance use the grid api method `getToolbarItemInstance(key)`. The `key` must match a `key` set on the item definition; items without an explicit key are not reachable via the API. This is demonstrated in the [Custom Components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/toolbar/#custom-components) example above, where it's used to keep a toolbar radio in sync with side bar tool panel changes.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getToolbarItemInstance` | `Function` |  |  |  |

## API Reference

### Toolbar

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `toolbar` | `Toolbar` |  |  |  |

### IToolbarItemParams

Properties available on the `IToolbarItemParams&lt;TData = any, TContext = any, TParams = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `key` | `string` |  |  |  |
| `alignment` | `'left' \| 'right'` |  |  |  |
| `toolbarItemParams` | `TParams` |  |  |  |
| `label` | `string` |  |  |  |
| `tooltip` | `string` |  |  |  |
| `icon` | `IconName` |  |  |  |
| `action` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |


---
product: "AG Grid"
title: "Quick Access Toolbar"
description: "The Toolbar appears above the grid and provides quick access to common grid actions. It supports built-in items such as quick filter and find, dropdown menus, and can be extended with or ."
enterprise: true
framework: angular
version: "36.2.0"
related:
    - title: "Tool Panels"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tool-panel/"
    - title: "Column Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-menu/"
    - title: "Column Chooser"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-chooser/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/context-menu/"
    - title: "Menu Item Component"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/component-menu-item/"
    - title: "Status Bar"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/status-bar/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Quick Access Toolbar

The Toolbar appears above the grid and provides quick access to common grid actions. It supports built-in items such as quick filter and find, dropdown menus, and can be extended with [Action Buttons](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/toolbar/#action-buttons) or [Custom Components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/toolbar/#custom-components).

#### Built-in Items

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnAutoSizeModule,
  CsvExportModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  QuickFilterModule,
  TextFilterModule,
  Toolbar,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  FindModule,
  PdfExportModule,
  ToolbarModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnAutoSizeModule,
  ContextMenuModule,
  CsvExportModule,
  ExcelExportModule,
  PdfExportModule,
  FindModule,
  QuickFilterModule,
  ToolbarModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [toolbar]="toolbar"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "country" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ];
  defaultColDef: ColDef = {
    minWidth: 100,
    filter: true,
  };
  toolbar: Toolbar = {
    items: [
      "agQuickFilterToolbarItem",
      "separator",
      "agFindToolbarItem",
      "separator",
      {
        label: "Fit Columns To Grid",
        icon: "maximize",
        alignment: "right",
        action: (params) => params.api.sizeColumnsToFit(),
      },
      {
        toolbarItem: "agMenuToolbarItem",
        icon: "save",
        alignment: "right",
        label: "Export",
        tooltip: "Export as CSV, Excel or PDF",
        toolbarItemParams: {
          menuItems: ["csvExport", "excelExport", "pdfExport"],
        },
      },
    ],
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Built-in Items](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/built-in-items/angular/)

## Configuring the Toolbar

Set the `toolbar` grid option to a [Toolbar](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grid-options/#reference-accessories-toolbar) object. The `items` array accepts built-in item names, [Action Buttons](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/toolbar/#action-buttons), and [Custom Components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/toolbar/#custom-components).

```ts
<ag-grid-angular
    [toolbar]="toolbar"
    /* other grid options ... */ />

this.toolbar = {
    items: [
        'agQuickFilterToolbarItem',
        'separator',
        'agFindToolbarItem',
        'separator',
        {
            label: 'Fit Columns To Grid',
            icon: 'maximize',
            alignment: 'right',
            action: (params) => params.api.sizeColumnsToFit(),
        },
        {
            toolbarItem: 'agMenuToolbarItem',
            icon: 'save',
            alignment: 'right',
            label: 'Download',
            tooltip: 'Download as CSV, Excel or PDF',
            toolbarItemParams: {
                menuItems: ['csvExport', 'excelExport', 'pdfExport'],
            },
        },
    ],
};
```

### Alignment

Toolbar items are aligned to the left by default. Set the `alignment` property on the toolbar to change the default alignment for all items, or set it individually per item.

```ts
<ag-grid-angular
    [toolbar]="toolbar"
    /* other grid options ... */ />

this.toolbar = {
    alignment: 'right',
    items: [
        'agFindToolbarItem',
        { toolbarItem: 'agQuickFilterToolbarItem', alignment: 'left' },
    ]
};
```

## Built-in Items

A number of built-in toolbar items are provided for common use cases that integrate with existing grid features. Be sure to include the required feature module, otherwise the toolbar item will be excluded.

| Item | Description | Required Modules |
| --- | --- | --- |
| `agQuickFilterToolbarItem` | Text input that filters grid rows using the [Quick Filter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-quick/). | `QuickFilterModule` |
| `agFindToolbarItem` | Text input that searches within grid cells using [Find](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/find/). | `FindModule` |
| `agRowGroupPanelToolbarItem` | Embeds the [Row Group Panel](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-group-panel/). | `RowGroupingPanelModule` |
| `agPivotPanelToolbarItem` | Embeds the [Pivot Panel](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/pivoting/#enabling-the-pivot-panel). | `RowGroupingPanelModule` |
| [`agMenuToolbarItem`](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/toolbar/#dropdown-menus) | Button that opens a [dropdown menu](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/toolbar/#dropdown-menus). | `ContextMenuModule` or `ColumnMenuModule` |
| `separator` | Vertical divider used to group items visually. Has no behaviour of its own. | None |

The Find and Quick Filter items' inputs share the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/input-fields/).

### Row Group and Pivot Panels

The Row Group Panel and Pivot Panel can both be embedded in the Quick Access Toolbar using `agRowGroupPanelToolbarItem` and `agPivotPanelToolbarItem`. Both panels are configured independently of the [Row Group Panel](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-group-panel/) and the [Pivot Panel](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/pivoting/#enabling-the-pivot-panel), so you can display each panel in the Toolbar, above the grid, or both at the same time.

The example below shows both panels in the toolbar along with a reset action button. Use the panels to rearrange columns, then click Reset to restore the initial layout.

#### Row Group and Pivot Panels

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Toolbar,
  enableDevValidations,
} from "ag-grid-community";
import {
  PivotModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  ToolbarModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnApiModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  PivotModule,
  ToolbarModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [pivotMode]="true"
    [toolbar]="toolbar"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "country", enableRowGroup: true, rowGroup: true },
    { field: "year", enableRowGroup: true, enablePivot: true, pivot: true },
    { field: "sport", enableRowGroup: true, enablePivot: true },
    { field: "gold", enableValue: true, aggFunc: "sum" },
    { field: "silver", enableValue: true, aggFunc: "sum" },
    { field: "total", enableValue: true, aggFunc: "sum" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 120,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
  };
  toolbar: Toolbar = {
    items: [
      "agRowGroupPanelToolbarItem",
      "separator",
      "agPivotPanelToolbarItem",
      "separator",
      {
        icon: "columns",
        label: "Reset",
        alignment: "right",
        action: (params) => {
          params.api.setGridOption("pivotMode", true);
          params.api.resetColumnState();
        },
      },
    ],
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Row Group and Pivot Panels](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/row-group-pivot-panels/angular/)

### Dropdown Menus

Use the `agMenuToolbarItem` to render a dropdown of [Menu Items](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/component-menu-item/). Configure the button and menu contents using the following properties:

- `label`: Visible text rendered next to the icon. Omit to render an icon-only button.
- `icon`: Icon displayed on the button. Accepts any [provided icon](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/custom-icons/#provided-icons).
- `tooltip`: Hover tooltip and `aria-label`. Falls back to `label` when omitted.
- `toolbarItemParams.menuItems`: Items to include in the dropdown. Each entry is either a `MenuItemDef` or one of the [built-in](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/context-menu/#built-in-menu-items) menu item names as used by the Context Menu.

```ts
<ag-grid-angular
    [toolbar]="toolbar"
    /* other grid options ... */ />

this.toolbar = {
    items: [
        {
            toolbarItem: 'agMenuToolbarItem',
            icon: 'save',
            toolbarItemParams: {
                menuItems: ['csvExport', 'excelExport', 'pdfExport'],
            },
        },
    ],
};
```

## Action Buttons

Action buttons provide a convenient way to trigger custom behaviour on click of a toolbar item. Configure an action button using the following properties:

- `label`: Visible text rendered next to the icon. Omit to render an icon-only button.
- `icon`: Icon displayed on the button. Accepts any [provided icon](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/custom-icons/#provided-icons).
- `tooltip`: Hover tooltip and `aria-label`. Falls back to `label` when omitted.
- `action`: Callback fired on click. Receives the grid `api`, `context`, and the item `key`.

```ts
<ag-grid-angular
    [toolbar]="toolbar"
    /* other grid options ... */ />

this.toolbar = {
    items: [
        {
            key: 'autoSizeAll',
            label: 'Auto Size All',
            icon: 'maximize',
            action: (params) => params.api.autoSizeAllColumns(),
        },
    ],
};
```

The example below shows icon-only buttons with tooltips for sizing columns, sorting, and resetting filters and column state, divided by separators.

#### Action Buttons

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  ColumnAutoSizeModule,
  CsvExportModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  Toolbar,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ToolbarModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  TextFilterModule,
  NumberFilterModule,
  ColumnMenuModule,
  CsvExportModule,
  ColumnAutoSizeModule,
  ColumnApiModule,
  ContextMenuModule,
  ToolbarModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [toolbar]="toolbar"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "country", filter: "agTextColumnFilter" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ];
  defaultColDef: ColDef = {
    minWidth: 100,
    filter: true,
  };
  toolbar: Toolbar = {
    items: [
      {
        key: "sizeColumnsToFit",
        icon: "maximize",
        tooltip: "Size Columns to Fit",
        action: (params) => params.api.sizeColumnsToFit(),
      },
      {
        key: "autoSizeAll",
        icon: "minimize",
        tooltip: "Auto-size All Columns",
        action: (params) => params.api.autoSizeAllColumns(),
      },
      "separator",
      {
        key: "sortFirstColumnAsc",
        icon: "sortAscending",
        tooltip: "Sort First Column Ascending",
        action: (params) =>
          params.api.applyColumnState({
            state: [{ colId: "athlete", sort: "asc" }],
            defaultState: { sort: null },
          }),
      },
      {
        key: "sortFirstColumnDesc",
        icon: "sortDescending",
        tooltip: "Sort First Column Descending",
        action: (params) =>
          params.api.applyColumnState({
            state: [{ colId: "athlete", sort: "desc" }],
            defaultState: { sort: null },
          }),
      },
      "separator",
      {
        key: "addFilter",
        icon: "filter-add",
        tooltip: "Add Filter",
        action: (params) =>
          params.api.setFilterModel({
            country: { filterType: "text", type: "contains", filter: "Canada" },
          }),
      },
      {
        key: "clearFilters",
        icon: "filterActive",
        tooltip: "Clear All Filters",
        action: (params) => params.api.setFilterModel(null),
      },
      "separator",
      {
        key: "showColumnChooser",
        icon: "columns",
        tooltip: "Open Column Chooser",
        action: (params) => params.api.showColumnChooser(),
      },
    ],
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Action Buttons](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/action-buttons/angular/)

## Custom Components

For controls beyond a button, such as toggles, inputs, or any stateful UI, set `toolbarItem` to a custom component. Custom components can render arbitrary HTML and call any grid API, so they suit cases that the [Action Button](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/toolbar/#action-buttons) shorthand cannot express.

The example below defines two custom items: checkbox toggles that apply column filters on the left, and a radio group that opens [Side Bar](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tool-panel/) tool panels on the right. The radio group's `setSelected` method is called via [`getToolbarItemInstance`](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/toolbar/#reference-accessories-getToolbarItemInstance) in `onToolPanelVisibleChanged` to stay in sync when a panel is opened or closed elsewhere, such as via a sidebar tab.

#### Custom Toolbar Item

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  AllCommunityModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  ToolPanelVisibleChangedEvent,
  Toolbar,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  SideBarModule,
  ToolbarModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  AllCommunityModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  SideBarModule,
  ToolbarModule,
]);
import { ToolPanelRadio } from "./tool-panel-radio.component";
import { WinnersToggle } from "./winners-toggle.component";
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, ToolPanelRadio, WinnersToggle],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [sideBar]="sideBar"
    [toolbar]="toolbar"
    [rowData]="rowData"
    (toolPanelVisibleChanged)="onToolPanelVisibleChanged($event)"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "country" },
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze" },
  ];
  defaultColDef: ColDef = {
    minWidth: 100,
    filter: true,
  };
  sideBar: SideBarDef | string | string[] | boolean | null = {
    toolPanels: ["columns", "filters"],
  };
  toolbar: Toolbar = {
    items: [
      { toolbarItem: WinnersToggle, key: "winners" },
      { toolbarItem: ToolPanelRadio, key: "toolPanel", alignment: "right" },
    ],
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onToolPanelVisibleChanged(event: ToolPanelVisibleChangedEvent) {
    const radio = event.api.getToolbarItemInstance<ToolPanelRadio>("toolPanel");
    radio?.setSelected(event.visible ? event.key : "none");
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Custom Toolbar Item](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/toolbar-custom/angular/)

When defining a custom component, provide the `toolbarItem` with:

1. `String`: the name of a registered Toolbar Item Component. See [Registering Custom Components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/components/#registering-custom-components).
2. `Component`: a direct reference to a Toolbar Item Component.

```js
// WinnersToggle and ToolPanelRadio are the custom components defined above.
// Any toolbarItemParams set on the item are accessible via params.toolbarItemParams inside the component.
this.gridOptions = {
    toolbar: {
        items: [
            { toolbarItem: WinnersToggle, key: 'winners' },
            { toolbarItem: ToolPanelRadio, key: 'toolPanel', alignment: 'right' },
        ],
    },
    // ...other properties
}
```

Implement this interface to create a toolbar item component.

```ts
interface IToolbarItemAngularComp {
    // mandatory methods

    // The agInit(params) method is called on the toolbar item component once.
    // See below for details on the parameters.
    agInit(params: IToolbarItemParams): void;

    // optional methods

    // Called when the `toolbar` grid option updates.
    // Return `true` if the component updates itself with the new params.
    // Return `false` (or omit) to have the grid destroy and recreate the component.
    refresh(params: IToolbarItemParams): boolean;
}
```

The `agInit(params)` method receives a params object that implements `IToolbarItemParams`:

## Theme Parameters

The toolbar exposes the following [Theme Parameters](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-parameters/):

| Parameter | Description |
| --- | --- |
| `toolbarBackgroundColor` | Background colour of the toolbar. Defaults to the header background colour. |
| `toolbarTextColor` | Text colour in the toolbar. Defaults to the header text colour. |
| `toolbarSeparatorBorder` | Border style for the vertical separator between toolbar items. |

## Accessing Toolbar Items

To access a toolbar item instance use the grid api method `getToolbarItemInstance(key)`. The `key` must match a `key` set on the item definition; items without an explicit key are not reachable via the API. This is demonstrated in the [Custom Components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/toolbar/#custom-components) example above, where it's used to keep a toolbar radio in sync with side bar tool panel changes.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getToolbarItemInstance` | `Function` |  |  |  |

## API Reference

### Toolbar

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `toolbar` | `Toolbar` |  |  |  |

### IToolbarItemParams

Properties available on the `IToolbarItemParams&lt;TData = any, TContext = any, TParams = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `key` | `string` |  |  |  |
| `alignment` | `'left' \| 'right'` |  |  |  |
| `toolbarItemParams` | `TParams` |  |  |  |
| `label` | `string` |  |  |  |
| `tooltip` | `string` |  |  |  |
| `icon` | `IconName` |  |  |  |
| `action` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |


---
product: "AG Grid"
title: "Quick Access Toolbar"
description: "The Toolbar appears above the grid and provides quick access to common grid actions. It supports built-in items such as quick filter and find, dropdown menus, and can be extended with or ."
enterprise: true
framework: react
version: "36.2.0"
related:
    - title: "Tool Panels"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/tool-panel/"
    - title: "Column Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-menu/"
    - title: "Column Chooser"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-chooser/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/context-menu/"
    - title: "Menu Item Component"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/component-menu-item/"
    - title: "Status Bar"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/status-bar/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Quick Access Toolbar

The Toolbar appears above the grid and provides quick access to common grid actions. It supports built-in items such as quick filter and find, dropdown menus, and can be extended with [Action Buttons](https://www.ag-grid.com/archive/36.2.0/react-data-grid/toolbar/#action-buttons) or [Custom Components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/toolbar/#custom-components).

#### Built-in Items

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnAutoSizeModule,
  CsvExportModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  QuickFilterModule,
  TextFilterModule,
  Toolbar,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  FindModule,
  PdfExportModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnAutoSizeModule,
  ContextMenuModule,
  CsvExportModule,
  ExcelExportModule,
  PdfExportModule,
  FindModule,
  QuickFilterModule,
  ToolbarModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "country" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      minWidth: 100,
      filter: true,
    };
  }, []);
  const toolbar = useMemo<Toolbar>(() => {
    return {
      items: [
        "agQuickFilterToolbarItem",
        "separator",
        "agFindToolbarItem",
        "separator",
        {
          label: "Fit Columns To Grid",
          icon: "maximize",
          alignment: "right",
          action: (params) => params.api.sizeColumnsToFit(),
        },
        {
          toolbarItem: "agMenuToolbarItem",
          icon: "save",
          alignment: "right",
          label: "Export",
          tooltip: "Export as CSV, Excel or PDF",
          toolbarItemParams: {
            menuItems: ["csvExport", "excelExport", "pdfExport"],
          },
        },
      ],
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            toolbar={toolbar}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Built-in Items](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/built-in-items/reactFunctionalTs/)

## Configuring the Toolbar

Set the `toolbar` grid option to a [Toolbar](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grid-options/#reference-accessories-toolbar) object. The `items` array accepts built-in item names, [Action Buttons](https://www.ag-grid.com/archive/36.2.0/react-data-grid/toolbar/#action-buttons), and [Custom Components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/toolbar/#custom-components).

```jsx
const toolbar = {
    items: [
        'agQuickFilterToolbarItem',
        'separator',
        'agFindToolbarItem',
        'separator',
        {
            label: 'Fit Columns To Grid',
            icon: 'maximize',
            alignment: 'right',
            action: (params) => params.api.sizeColumnsToFit(),
        },
        {
            toolbarItem: 'agMenuToolbarItem',
            icon: 'save',
            alignment: 'right',
            label: 'Download',
            tooltip: 'Download as CSV, Excel or PDF',
            toolbarItemParams: {
                menuItems: ['csvExport', 'excelExport', 'pdfExport'],
            },
        },
    ],
};

<AgGridReact toolbar={toolbar} />
```

### Alignment

Toolbar items are aligned to the left by default. Set the `alignment` property on the toolbar to change the default alignment for all items, or set it individually per item.

```jsx
const toolbar = {
    alignment: 'right',
    items: [
        'agFindToolbarItem',
        { toolbarItem: 'agQuickFilterToolbarItem', alignment: 'left' },
    ]
};

<AgGridReact toolbar={toolbar} />
```

## Built-in Items

A number of built-in toolbar items are provided for common use cases that integrate with existing grid features. Be sure to include the required feature module, otherwise the toolbar item will be excluded.

| Item | Description | Required Modules |
| --- | --- | --- |
| `agQuickFilterToolbarItem` | Text input that filters grid rows using the [Quick Filter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-quick/). | `QuickFilterModule` |
| `agFindToolbarItem` | Text input that searches within grid cells using [Find](https://www.ag-grid.com/archive/36.2.0/react-data-grid/find/). | `FindModule` |
| `agRowGroupPanelToolbarItem` | Embeds the [Row Group Panel](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-group-panel/). | `RowGroupingPanelModule` |
| `agPivotPanelToolbarItem` | Embeds the [Pivot Panel](https://www.ag-grid.com/archive/36.2.0/react-data-grid/pivoting/#enabling-the-pivot-panel). | `RowGroupingPanelModule` |
| [`agMenuToolbarItem`](https://www.ag-grid.com/archive/36.2.0/react-data-grid/toolbar/#dropdown-menus) | Button that opens a [dropdown menu](https://www.ag-grid.com/archive/36.2.0/react-data-grid/toolbar/#dropdown-menus). | `ContextMenuModule` or `ColumnMenuModule` |
| `separator` | Vertical divider used to group items visually. Has no behaviour of its own. | None |

The Find and Quick Filter items' inputs share the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/react-data-grid/input-fields/).

### Row Group and Pivot Panels

The Row Group Panel and Pivot Panel can both be embedded in the Quick Access Toolbar using `agRowGroupPanelToolbarItem` and `agPivotPanelToolbarItem`. Both panels are configured independently of the [Row Group Panel](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-group-panel/) and the [Pivot Panel](https://www.ag-grid.com/archive/36.2.0/react-data-grid/pivoting/#enabling-the-pivot-panel), so you can display each panel in the Toolbar, above the grid, or both at the same time.

The example below shows both panels in the toolbar along with a reset action button. Use the panels to rearrange columns, then click Reset to restore the initial layout.

#### Row Group and Pivot Panels

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  Toolbar,
  enableDevValidations,
} from "ag-grid-community";
import {
  PivotModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnApiModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  PivotModule,
  ToolbarModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "country", enableRowGroup: true, rowGroup: true },
    { field: "year", enableRowGroup: true, enablePivot: true, pivot: true },
    { field: "sport", enableRowGroup: true, enablePivot: true },
    { field: "gold", enableValue: true, aggFunc: "sum" },
    { field: "silver", enableValue: true, aggFunc: "sum" },
    { field: "total", enableValue: true, aggFunc: "sum" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 120,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
    };
  }, []);
  const toolbar = useMemo<Toolbar>(() => {
    return {
      items: [
        "agRowGroupPanelToolbarItem",
        "separator",
        "agPivotPanelToolbarItem",
        "separator",
        {
          icon: "columns",
          label: "Reset",
          alignment: "right",
          action: (params) => {
            params.api.setGridOption("pivotMode", true);
            params.api.resetColumnState();
          },
        },
      ],
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            autoGroupColumnDef={autoGroupColumnDef}
            pivotMode={true}
            toolbar={toolbar}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Row Group and Pivot Panels](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/row-group-pivot-panels/reactFunctionalTs/)

### Dropdown Menus

Use the `agMenuToolbarItem` to render a dropdown of [Menu Items](https://www.ag-grid.com/archive/36.2.0/react-data-grid/component-menu-item/). Configure the button and menu contents using the following properties:

- `label`: Visible text rendered next to the icon. Omit to render an icon-only button.
- `icon`: Icon displayed on the button. Accepts any [provided icon](https://www.ag-grid.com/archive/36.2.0/react-data-grid/custom-icons/#provided-icons).
- `tooltip`: Hover tooltip and `aria-label`. Falls back to `label` when omitted.
- `toolbarItemParams.menuItems`: Items to include in the dropdown. Each entry is either a `MenuItemDef` or one of the [built-in](https://www.ag-grid.com/archive/36.2.0/react-data-grid/context-menu/#built-in-menu-items) menu item names as used by the Context Menu.

```jsx
const toolbar = {
    items: [
        {
            toolbarItem: 'agMenuToolbarItem',
            icon: 'save',
            toolbarItemParams: {
                menuItems: ['csvExport', 'excelExport', 'pdfExport'],
            },
        },
    ],
};

<AgGridReact toolbar={toolbar} />
```

## Action Buttons

Action buttons provide a convenient way to trigger custom behaviour on click of a toolbar item. Configure an action button using the following properties:

- `label`: Visible text rendered next to the icon. Omit to render an icon-only button.
- `icon`: Icon displayed on the button. Accepts any [provided icon](https://www.ag-grid.com/archive/36.2.0/react-data-grid/custom-icons/#provided-icons).
- `tooltip`: Hover tooltip and `aria-label`. Falls back to `label` when omitted.
- `action`: Callback fired on click. Receives the grid `api`, `context`, and the item `key`.

```jsx
const toolbar = {
    items: [
        {
            key: 'autoSizeAll',
            label: 'Auto Size All',
            icon: 'maximize',
            action: (params) => params.api.autoSizeAllColumns(),
        },
    ],
};

<AgGridReact toolbar={toolbar} />
```

The example below shows icon-only buttons with tooltips for sizing columns, sorting, and resetting filters and column state, divided by separators.

#### Action Buttons

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  ColumnAutoSizeModule,
  CsvExportModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  Toolbar,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  TextFilterModule,
  NumberFilterModule,
  ColumnMenuModule,
  CsvExportModule,
  ColumnAutoSizeModule,
  ColumnApiModule,
  ContextMenuModule,
  ToolbarModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "country", filter: "agTextColumnFilter" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      minWidth: 100,
      filter: true,
    };
  }, []);
  const toolbar = useMemo<Toolbar>(() => {
    return {
      items: [
        {
          key: "sizeColumnsToFit",
          icon: "maximize",
          tooltip: "Size Columns to Fit",
          action: (params) => params.api.sizeColumnsToFit(),
        },
        {
          key: "autoSizeAll",
          icon: "minimize",
          tooltip: "Auto-size All Columns",
          action: (params) => params.api.autoSizeAllColumns(),
        },
        "separator",
        {
          key: "sortFirstColumnAsc",
          icon: "sortAscending",
          tooltip: "Sort First Column Ascending",
          action: (params) =>
            params.api.applyColumnState({
              state: [{ colId: "athlete", sort: "asc" }],
              defaultState: { sort: null },
            }),
        },
        {
          key: "sortFirstColumnDesc",
          icon: "sortDescending",
          tooltip: "Sort First Column Descending",
          action: (params) =>
            params.api.applyColumnState({
              state: [{ colId: "athlete", sort: "desc" }],
              defaultState: { sort: null },
            }),
        },
        "separator",
        {
          key: "addFilter",
          icon: "filter-add",
          tooltip: "Add Filter",
          action: (params) =>
            params.api.setFilterModel({
              country: {
                filterType: "text",
                type: "contains",
                filter: "Canada",
              },
            }),
        },
        {
          key: "clearFilters",
          icon: "filterActive",
          tooltip: "Clear All Filters",
          action: (params) => params.api.setFilterModel(null),
        },
        "separator",
        {
          key: "showColumnChooser",
          icon: "columns",
          tooltip: "Open Column Chooser",
          action: (params) => params.api.showColumnChooser(),
        },
      ],
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            toolbar={toolbar}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Action Buttons](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/action-buttons/reactFunctionalTs/)

## Custom Components

For controls beyond a button, such as toggles, inputs, or any stateful UI, set `toolbarItem` to a custom component. Custom components can render arbitrary HTML and call any grid API, so they suit cases that the [Action Button](https://www.ag-grid.com/archive/36.2.0/react-data-grid/toolbar/#action-buttons) shorthand cannot express.

The example below defines two custom items: checkbox toggles that apply column filters on the left, and a radio group that opens [Side Bar](https://www.ag-grid.com/archive/36.2.0/react-data-grid/tool-panel/) tool panels on the right. The radio group's `setSelected` method is called via [`getToolbarItemInstance`](https://www.ag-grid.com/archive/36.2.0/react-data-grid/toolbar/#reference-accessories-getToolbarItemInstance) in `onToolPanelVisibleChanged` to stay in sync when a panel is opened or closed elsewhere, such as via a sidebar tab.

#### Custom Toolbar Item

```tsx
'use client';
import React, {
  StrictMode,
  useCallback,
  useEffect,
  useMemo,
  useState,
} from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  ToolPanelVisibleChangedEvent,
  Toolbar,
} from "ag-grid-community";
import { AllCommunityModule } from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  SideBarModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import {
  ToolPanelRadio,
  type ToolPanelRadioHandle,
  WinnersToggle,
} from "./customToolbarItem";
import "./styles.css";

const modules = [
  AllCommunityModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  SideBarModule,
  ToolbarModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>();

  useEffect(() => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((response) => response.json())
      .then((data) => setRowData(data));
  }, []);

  const columnDefs = useMemo<ColDef[]>(
    () => [
      { field: "athlete" },
      { field: "country" },
      { field: "gold", filter: "agNumberColumnFilter" },
      { field: "silver", filter: "agNumberColumnFilter" },
      { field: "bronze" },
    ],
    [],
  );
  const defaultColDef = useMemo<ColDef>(
    () => ({
      minWidth: 100,
      filter: true,
    }),
    [],
  );
  const sideBar = useMemo(() => ({ toolPanels: ["columns", "filters"] }), []);
  const toolbar = useMemo<Toolbar>(
    () => ({
      items: [
        { toolbarItem: WinnersToggle, key: "winners" },
        { toolbarItem: ToolPanelRadio, key: "toolPanel", alignment: "right" },
      ],
    }),
    [],
  );
  const onToolPanelVisibleChanged = useCallback(
    (event: ToolPanelVisibleChangedEvent) => {
      const radio =
        event.api.getToolbarItemInstance<ToolPanelRadioHandle>("toolPanel");
      radio?.setSelected(event.visible ? event.key : "none");
    },
    [],
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            sideBar={sideBar}
            toolbar={toolbar}
            onToolPanelVisibleChanged={onToolPanelVisibleChanged}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Custom Toolbar Item](https://www.ag-grid.com/archive/36.2.0/examples/toolbar/toolbar-custom/reactFunctionalTs/)

When defining a custom component, provide the `toolbarItem` with:

1. `String`: the name of a registered Toolbar Item Component. See [Registering Custom Components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/components/#registering-custom-components).
2. `Component`: a direct reference to a Toolbar Item Component.

```jsx
{/* WinnersToggle and ToolPanelRadio are the custom components defined above. */}
{/* Any toolbarItemParams set on the item are accessible via props.toolbarItemParams inside the component. */}
<AgGridReact
    toolbar={{
        items: [
            { toolbarItem: WinnersToggle, key: 'winners' },
            { toolbarItem: ToolPanelRadio, key: 'toolPanel', alignment: 'right' },
        ],
    }}
    // ...other props
/>
```

When a toolbar item component is instantiated then the following will be made available on `props`:

## Theme Parameters

The toolbar exposes the following [Theme Parameters](https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-parameters/):

| Parameter | Description |
| --- | --- |
| `toolbarBackgroundColor` | Background colour of the toolbar. Defaults to the header background colour. |
| `toolbarTextColor` | Text colour in the toolbar. Defaults to the header text colour. |
| `toolbarSeparatorBorder` | Border style for the vertical separator between toolbar items. |

## Accessing Toolbar Items

To access a toolbar item instance use the grid api method `getToolbarItemInstance(key)`. The `key` must match a `key` set on the item definition; items without an explicit key are not reachable via the API. This is demonstrated in the [Custom Components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/toolbar/#custom-components) example above, where it's used to keep a toolbar radio in sync with side bar tool panel changes.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getToolbarItemInstance` | `Function` |  |  |  |

## API Reference

### Toolbar

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `toolbar` | `Toolbar` |  |  |  |

### IToolbarItemParams

Properties available on the `IToolbarItemParams&lt;TData = any, TContext = any, TParams = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `key` | `string` |  |  |  |
| `alignment` | `'left' \| 'right'` |  |  |  |
| `toolbarItemParams` | `TParams` |  |  |  |
| `label` | `string` |  |  |  |
| `tooltip` | `string` |  |  |  |
| `icon` | `IconName` |  |  |  |
| `action` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |
